use std::time::{Duration, Instant};

#[allow(dead_code)]
fn delay_task(delay_time: usize) -> impl Fn() -> () {
    // 记录当前时间
    let start_time = Instant::now();
    return move || {
        if Instant::now() - start_time > Duration::from_secs(delay_time as u64) {
            println!("已经经过了至少: {:?}秒", delay_time);
        }
    };
}

fn main() {
    let delay_seconds_time: usize = 5;
    let task = delay_task(delay_seconds_time);
    loop {
        task();
        std::thread::sleep(Duration::from_millis(500)); // 休眠500ms
    }
}
