use std::time::{Duration, Instant};

#[allow(dead_code)]
fn delay_task(delay_time: usize) -> impl Fn() -> bool {
    // 记录当前时间
    let start_time = Instant::now();
    return move || {
        if Instant::now() - start_time > Duration::from_secs(delay_time as u64) {
            println!("已经经过了至少: {:?}秒", delay_time);
            return true;
        }
        false
    };
}
const TIME_PIECE: usize = 500;
fn main() {
    let delay_seconds_time: usize = 5;
    let task01 = delay_task(delay_seconds_time);
    let task02 = delay_task(delay_seconds_time * 2);
    let mut task01_is_done = false;
    let mut task02_is_done = false;
    loop {
        if !task01_is_done {
            task01_is_done = task01();
        }
        if !task02_is_done {
            task02_is_done = task02();
        }
        if task01_is_done && task02_is_done {
            break;
        }
        std::thread::sleep(Duration::from_millis(TIME_PIECE as u64)); // 休眠500ms
    }
    println!("退出主线程！");
}
